#include "peGame.h"

bool xArrowManager::Update(double dTime)
{
	m_bMissedArrow = false;

//	m_dwMusicTime		= g_pPaperAPI->m_pAudio->MusicGetTime();
//	m_dwCurTime			= g_pPaperAPI->m_pPlatform->GetTime();
//	m_dwSongStartTime	= m_dwCurTime - m_dwMusicTime;

	if(!g_xGameOptions.m_bArrows)
	{
		m_dCurHitTime += dTime;
		if(m_dCurHitTime >= 60.0 / g_xGameOptions.m_iBPM)
		{
			m_dCurHitTime -= (60.0 / g_xGameOptions.m_iBPM);

			if(!m_bAddedBlockAlready && g_xGameOptions.m_bAlwaysAddBlock)
				m_bMissedArrow = true;

			m_bAddedBlockAlready = false;
		}
	}
	else
	{
		if(!m_pCurArrow)
			m_pCurArrow = m_xArrows.m_pNext;
		if(m_pCurArrow && m_pCurArrow->m_fY > BB_ARROWTARGETY + 64)
		{
			if(!m_bAddedBlockAlready && g_xGameOptions.m_bAlwaysAddBlock)
				m_bMissedArrow = true;

			if(m_pCurArrow->m_pNext)
				m_pCurArrow = m_pCurArrow->m_pNext;

			if(m_iComboCount == m_iOldComboCount) //They skipped an arrow, reset the ComboCount.
			{
				m_iOldComboCount = m_iComboCount;
				m_iComboCount	 = 0;
			}
			else
				m_iOldComboCount	 = m_iComboCount;

			m_bAddedBlockAlready = false;
		}

		if(m_pCurArrowObject && m_pCurArrowObject->m_pArrowObject->m_fY > -64.0)
		{
			if(m_pNewestArrow->m_pNext)
			{
				m_pNewestArrow = m_pNewestArrow->m_pNext;

				if(m_pCurArrowObject->m_pNext)
					m_pCurArrowObject = m_pCurArrowObject->m_pNext;			
				else
					m_pCurArrowObject = m_xArrowObjects.m_pNext;

				m_pCurArrowObject->m_pArrowObject->m_fX = m_pNewestArrow->m_fX;
				m_pCurArrowObject->m_pArrowObject->m_fY = m_pNewestArrow->m_fY;
			}
		}

		xArrow *curarrow = &m_xArrows;
		while(curarrow->m_pNext)
		{
			curarrow = curarrow->m_pNext;

			curarrow->m_fY += (float)(dTime * (128 / (60.0 / g_xGameOptions.m_iBPM)));
		}

		xArrowObject *curarrowobject = &m_xArrowObjects;
		while(curarrowobject->m_pNext)
		{
			curarrowobject = curarrowobject->m_pNext;

			curarrowobject->m_pArrowObject->m_fY += (float)(dTime * (128 / (60.0 / g_xGameOptions.m_iBPM)));
			curarrowobject->m_pArrowObject->Update(dTime);
			curarrowobject->m_pArrowObject->Render();
		}

	}
	return true;
}

bool xArrowManager::AddArrow(xDir iDir, DWORD dwTime)
{
	xArrow *curarrow = &m_xArrows;

	if(!m_bInitialized)
	{
		m_pCurArrowObject = &m_xArrowObjects;
		for(int i = 0; i < BB_MAXARROWSONSCREEN; i++)
		{
			m_pCurArrowObject->m_pNext			= new xArrowObject;
			m_pCurArrowObject->m_pNext->m_pPrev	= m_pCurArrowObject;
			m_pCurArrowObject					= m_pCurArrowObject->m_pNext;
			m_pCurArrowObject->m_pArrowObject	= g_pPaperAPI->m_pGraphics->Create2DObject("images/BeatMarker.p2d");
		}

		m_pCurArrowObject = &m_xArrowObjects;

		m_bInitialized = true;
	}

	while(curarrow->m_pNext)
		curarrow = curarrow->m_pNext;

	curarrow->m_pNext			= new xArrow;
	curarrow->m_pNext->m_pPrev	= curarrow;
	curarrow					= curarrow->m_pNext;

	curarrow->m_dwArrowsTime	= dwTime;
	curarrow->m_fX				= BB_ARROWTARGETX;
	curarrow->m_fY				= BB_ARROWTARGETY - (float)dwTime * (256.0f / 1000.0f);

	if(m_iArrowsLoaded < BB_MAXARROWSONSCREEN)
	{
		m_pNewestArrow = curarrow;
		m_iArrowsLoaded++;
	}

	if(m_pCurArrowObject->m_pNext)
	{
		m_pCurArrowObject = m_pCurArrowObject->m_pNext;

		if(!m_pCurArrowObject->m_pArrowObject->m_fX)
		{
			m_pCurArrowObject->m_pArrowObject->m_fX = m_pNewestArrow->m_fX;
			m_pCurArrowObject->m_pArrowObject->m_fY = m_pNewestArrow->m_fY;
		}
	}

	return true;
}

void xArrowManager::Shutdown()
{
	if(m_xArrows.m_pNext)
	{
		m_pCurArrow = m_xArrows.m_pNext;
		while(m_pCurArrow->m_pNext)
		{
			m_pCurArrow = m_pCurArrow->m_pNext;
			delete m_pCurArrow->m_pPrev;
		}

		delete m_pCurArrow;
	}

	if(m_xArrowObjects.m_pNext)
	{
		m_pCurArrowObject = m_xArrowObjects.m_pNext;
		while(m_pCurArrowObject->m_pNext)
		{
			delete m_pCurArrowObject->m_pArrowObject;
			m_pCurArrowObject = m_pCurArrowObject->m_pNext;
			delete m_pCurArrowObject->m_pPrev;
		}

		delete m_pCurArrowObject->m_pArrowObject;
		delete m_pCurArrowObject;
	}
}