/////////////////////////////////////////////////////////////////
// Name: xSWFLoader.h
/////////////////////////////////////////////////////////////////
// Description:
// - Loads a Flash Shockwave File.
/////////////////////////////////////////////////////////////////
// - 12.29.2009, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XSWFLOADER_H_
#define XSWFLOADER_H_

#include "xFileIO.h"

enum xSWFTagCode
{
//	PE_SWF_TAGCODE_END = 0,
//	PE_SWF_TAGCODE_SHOWFRAME = 1,
	PE_SWF_TAGCODE_DEFINESHAPE = 2,
	PE_SWF_TAGCODE_PLACEOBJECT = 4,
	PE_SWF_TAGCODE_REMOVEOBJECT = 5,
//	PE_SWF_TAGCODE_DEFINEBITS = 6, //JPEG Image Bits
//	PE_SWF_TAGCODE_JPEGTABLES = 8,
//	PE_SWF_TAGCODE_SETBGCOLOR = 9,
//	PE_SWF_TAGCODE_DEFINEFONT = 10, and DefineFontInfo = 13 and DefineFont2 = 48 and DefineFontInfo2 = 62 and DefineFont3 = 75 and DefineFont4 = 91
//	PE_SWF_TAGCODE_DEFINETEXT = 11, and DefineText2 = 33
//	PE_SWF_TAGCODE_DOACTION = 12, and InitAction = 59
//	PE_SWF_TAGCODE_DEFINEBITSLOSSLESS = 20, //Bitmap Image Bits(no compression)
//	PE_SWF_TAGCODE_DEFINEBITSJPEG2 = 21, //New JPEG Image Bits
	PE_SWF_TAGCODE_DEFINESHAPE2 = 22,
	PE_SWF_TAGCODE_PLACEOBJECT2 = 26,
	PE_SWF_TAGCODE_REMOVEOBJECT2 = 28,
	PE_SWF_TAGCODE_DEFINESHAPE3 = 32,
//	PE_SWF_TAGCODE_DEFINEBITSJPEG3 = 35, //Newer JPEG Image Bits
//	PE_SWF_TAGCODE_DEFINEBITSLOSSLESS2 = 36, //New Bitmap Image Bits(no compression)
//	PE_SWF_TAGCODE_DEFINESPRITE = 39,
	PE_SWF_TAGCODE_FRAMELABEL = 43,
//	PE_SWF_TAGCODE_DEFINEMORPHSHAPE = 46,
//	PE_SWF_TAGCODE_FILEATTRIBUTES = 69,
	PE_SWF_TAGCODE_PLACEOBJECT3 = 70,
	PE_SWF_TAGCODE_DEFINESHAPE4 = 83,
//	PE_SWF_TAGCODE_DEFINEMORPHSHAPE2 = 84,
//	PE_SWF_TAGCODE_SCENEDATA = 86,
//	PE_SWF_TAGCODE_DEFINEBITSJPEG4 = 90, //Newest JPEG Image Bits
};

class xSWFLoader
{
public:
	int LoadFile(char* strFilePath);

private:
	inline void GetUnsignedInt16(unsigned int &uiOut);
	inline void GetRect(RECT &rectOut);
	inline void GetTagCodeAndSize(unsigned int &uiCode, unsigned int &uiSize);

	inline void SkipHalfPrecisionFloat() { m_uiFileBufferOffset += 2; }
	inline void SkipRect();

	inline void DefineShape();

	xFileIO			*m_pFile;
	byte			 m_byteVersion;
	unsigned int	*m_uiFileSize;
	byte			*m_pFileBuffer;
	unsigned int	 m_uiFileBufferOffset;
	unsigned int	 m_uiFrameCount;

	int		 m_iResult;
};

void xSWFLoader::GetUnsignedInt16(unsigned int &uiOut)
{
	uiOut = (*((unsigned int*)(m_pFileBuffer + m_uiFileBufferOffset))) & 0x0000FFFF;

	m_uiFileBufferOffset += 2;
}

void xSWFLoader::GetRect(RECT &rectOut)
{
	//NOTE: Rect structure is a bit field, so it's Big Endian

	//Get the number of bits per rect value field(XMin, XMax, YMin, YMax)
	//It's the upper 5 bits of the current byte
	byte bitsperfield = (m_pFileBuffer[m_uiFileBufferOffset] & 0xF8) >> 3;
	byte temp = bitsperfield - 3;
	byte bitmask;

	rectOut.left = (m_pFileBuffer[m_uiFileBufferOffset++] & 0x07) << temp;

	while(temp > 8)
	{
		temp -= 8;
		rectOut.left += m_pFileBuffer[m_uiFileBufferOffset] << temp;
		m_uiFileBufferOffset++;
	}

	bitmask = 0xFF << (8 - temp);
	rectOut.left += m_pFileBuffer[m_uiFileBufferOffset] & bitmask;

	bitmask = bitmask ^ 0xFF;
	temp = bitsperfield - (8 - temp);

	rectOut.right = (m_pFileBuffer[m_uiFileBufferOffset++] & bitmask) << temp;

	while(temp > 8)
	{
		temp -= 8;
		rectOut.right += m_pFileBuffer[m_uiFileBufferOffset] << temp;
		m_uiFileBufferOffset++;
	}

	bitmask = 0xFF << (8 - temp);
	rectOut.right += m_pFileBuffer[m_uiFileBufferOffset] & bitmask;

	bitmask = bitmask ^ 0xFF;
	temp = bitsperfield - (8 - temp);

	rectOut.top = (m_pFileBuffer[m_uiFileBufferOffset++] & bitmask) << temp;

	while(temp > 8)
	{
		temp -= 8;
		rectOut.top += m_pFileBuffer[m_uiFileBufferOffset] << temp;
		m_uiFileBufferOffset++;
	}

	bitmask = 0xFF << (8 - temp);
	rectOut.top += m_pFileBuffer[m_uiFileBufferOffset] & bitmask;

	bitmask = bitmask ^ 0xFF;
	temp = bitsperfield - (8 - temp);

	rectOut.bottom = (m_pFileBuffer[m_uiFileBufferOffset++] & bitmask) << temp;

	while(temp > 8)
	{
		temp -= 8;
		rectOut.bottom += m_pFileBuffer[m_uiFileBufferOffset] << temp;
		m_uiFileBufferOffset++;
	}

	bitmask = 0xFF << (8 - temp);
	rectOut.bottom += m_pFileBuffer[m_uiFileBufferOffset] & bitmask;

	m_uiFileBufferOffset++;
}

void xSWFLoader::GetTagCodeAndSize(unsigned int &uiCode, unsigned int &uiSize)
{
	//NOTE: Tag Code and Size is not a Bit Field, but rather an 2 byte unsigned int,
	// which means the first bits are in the second byte(Little Endian)

	unsigned int temp;
	
	//Code is first 10 bits
	//uiCode  = ((unsigned int)m_pFileBuffer[m_uiFileBufferOffset + 1]) << 2;
	//uiCode += m_pFileBuffer[m_uiFileBufferOffset] >> 6;
	uiCode = (*((unsigned int*)(m_pFileBuffer + m_uiFileBufferOffset)) & 0x0000FFC0) >> 6;

	//Size is the next 6 bits, if it's a short tag
	//uiSize = m_pFileBuffer[m_uiFileBufferOffset] & 0x3F;
	uiSize = *((unsigned int*)(m_pFileBuffer + m_uiFileBufferOffset)) & 0x0000003F;

	m_uiFileBufferOffset += 2;

	//If size is 63, then this is a long tag, the size is the next 32 bits
	if(uiSize == 63)
	{
		uiSize = *((int*)(m_pFileBuffer + m_uiFileBufferOffset));
		m_uiFileBufferOffset += 4;
	}

}

void xSWFLoader::SkipRect()
{
	//Get the number of bits per rect value field(XMin, XMax, YMin, YMax)
	//It's the upper 5 bits of the current byte
	unsigned int temp = (*((unsigned int*)(m_pFileBuffer + m_uiFileBufferOffset)) & 0x000000F8) >> 3;

	temp = 5 + temp * 4;

	if(temp % 8 == 0)
		m_uiFileBufferOffset += temp / 8;
	else
		m_uiFileBufferOffset += (unsigned int)(temp / 8) + 1;
}

void xSWFLoader::DefineShape()
{
	//Read in the Fill Styles

}

#endif
