/////////////////////////////////////////////////////////////////
// Name: xPaper.h
/////////////////////////////////////////////////////////////////
// Description:
// - This is the main include for every cpp file and
//   every program using the Paper Engine
/////////////////////////////////////////////////////////////////
// - 17.7.2004, Update, Arto Ruotsalainen (Arex)
//   Added VK KEY macro, it can be used without directinput.
//
// - 7.7.2004, Update, Dayle Flowers(Xienen)
//   Moved xFileStructures.h include into here from xGraphics.h
//
// - 7.6.2004, Update, Arto Ruotsalainen(Arex)
//   Comment stuff added to begin of the file.
//   Add new updates/fixes above this, so the old updates
//   will be at the bottom.
/////////////////////////////////////////////////////////////////
#ifndef PAPER_H_
#define PAPER_H_

#include <Carbon/Carbon.h>

#include <assert.h>
#include "AllocDebug.h"

#include "xEngineDefines.h"
#include "xEngineSettings.h"

#include "xVector.h"
#include "xColor.h"

#include "xEncryption.h"
#include "xPrivateKey.h"

#include "xFileStructures.h"
#include "xResults.h"

#include "xPoolItem.h"
#include "xPool.h"

#include "xPlatform.h"
#include "xInput.h"
#include "xFileIO.h"
#include "xGraphics.h"
#include "xAudio.h"
#include "xNetworkClient.h"

#include "xSound.h"
#include "xTexture.h"

#include "xRenderable2D.h"
#include "xRenderable2DLine.h"
#include "xRenderable2DBox.h"
#include "xRenderable2DQuad.h"
#include "xEmitter.h"

#include "xRenderable3D.h"
#include "xModel.h"
#include "xMD3Model.h"

#include "xGUI.h"
#include "xFont.h"

#include "xParser.h"

#define PE_CLASSNAME "Paper Engine v0.0.2 Beta"

// Use this to convert degrees to radians
extern const float g_DegToRadMultiplier;

#include "xPaper.h"

extern xPaper g_xPaperAPI;

#endif