/////////////////////////////////////////////////////////////////
// Name: peGame.h
/////////////////////////////////////////////////////////////////
// Description:
// - The main header for every Paper Engine Game Project
/////////////////////////////////////////////////////////////////
// - 7.17.2004, Update, Dayle Flowers(Xienen)
//   Created a global xGameState to hold the currently active
//   Game State class
//
// - 7.8.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef PEGAME_H_
#define PEGAME_H_

#include "Paper.h"

#include <string.h>

#include "xGameDefines.h"

#include "xGameNetwork.h"
#include "xHTTPQuery.h"

#include "xGameState.h"
#include "xMenu.h"
#include "xGame.h"
#include "xGameOptions.h"

#include "xField.h"
#include "xPiece.h"
#include "xBlock.h"

#include "xPlayer.h"
#include "xLocalPlayer.h"
#include "xNetPlayer.h"

#include "xPlayerProfile.h"
#include "xOptions.h"

#include "xBeatManager.h"
#include "xMultiplier.h"

#if WITH_BALANCESTATS
	#include "xBalanceStats.h"
	extern xBalanceStats g_xBalanceStats;
#endif

extern xPaper		 g_xPaperAPI;
extern xGameState	*g_pCurGameState;
extern xGame		 g_xGame;
extern xMenu		 g_xMenu;
extern xOptions		 g_xOptions;
extern xGameOptions	 g_xGameOptions;
extern xPlayerProfile	 g_xCurrentProfile;

// Credits Helpers
#define CREDIT_LINES 48
extern bool		  g_bCreditsRolling;
extern int		  g_iMaxCreditLines;
extern xGUIText	**g_pCreditTextArray;
extern int		  g_iCurTextLine;
extern int		  g_iCurCreditLine;
extern char		 *g_strCredits[CREDIT_LINES];

// Encrypted Strings
#define BB_ENCRYPTED_LENGTH_CDKEYFILE		4
extern	uint32_t	g_pEncryptedCDKeyFile[BB_ENCRYPTED_LENGTH_CDKEYFILE];			//"BreakBlocks.lic"

#define BB_ENCRYPTED_LENGTH_CDKEYWINDOW		3
extern	uint32_t	g_pEncryptedCDKeyWindow[BB_ENCRYPTED_LENGTH_CDKEYWINDOW];		//"MenuCDKey"

#define BB_ENCRYPTED_LENGTH_STOREKEY		2
extern	uint32_t	g_pEncryptedStoreKeyString[BB_ENCRYPTED_LENGTH_STOREKEY];		//"StoreKey"
extern	char		g_strStoreKey[32];

#define BB_ENCRYPTED_LENGTH_CDKEYINVALID1	15
extern	uint32_t	g_pEncryptedCDKeyInvalid1[BB_ENCRYPTED_LENGTH_CDKEYINVALID1];	//"The CD-Key you have entered is invalid, please contact us at"

#define BB_ENCRYPTED_LENGTH_CDKEYINVALID2	11
extern	uint32_t	g_pEncryptedCDKeyInvalid2[BB_ENCRYPTED_LENGTH_CDKEYINVALID2];	//"www.greatergoodgames.org if you need help"

#define BB_ENCRYPTED_LENGTH_SINGLEPLAYER 3
extern	uint32_t	g_pEncryptedSingleplayerString[BB_ENCRYPTED_LENGTH_SINGLEPLAYER];
extern	char		g_strSingleplayer[32];

#define BB_ENCRYPTED_LENGTH_CHALLENGES 3
extern	uint32_t	g_pEncryptedChallengesString[BB_ENCRYPTED_LENGTH_CHALLENGES];
extern	char		g_strChallenges[32];

#define BB_ENCRYPTED_LENGTH_FREEPLAY 2
extern	uint32_t	g_pEncryptedFreePlayString[BB_ENCRYPTED_LENGTH_FREEPLAY];
extern	char		g_strFreePlay[32];

#define BB_ENCRYPTED_LENGTH_CONTINUESINGLEPLAYER 5
extern	uint32_t	g_pEncryptedContinueSingleplayerString[BB_ENCRYPTED_LENGTH_CONTINUESINGLEPLAYER];
extern	char		g_strContinueSingleplayer[32];

#ifdef _DEBUG
	extern xFont g_xDebugFont;
#endif

void GameInitEngineSettings();
void GameInit();
void GamePreUpdate(DWORD dwTime);
void GameUpdate(double dTime);
void GameShutdown();

#endif