#include "peGame.h"

float xBeatManager::AddBeat(DWORD dwTime, char cNextBeat)
{
	if((cNextBeat >= 'a' && cNextBeat <= 'z') || (cNextBeat >= 'A' && cNextBeat <= 'Z'))
		m_dwBeatTimes[m_iNumBeats++] = dwTime;

	switch(cNextBeat)
	{
		case '0':
		case 'a':
		case 'A':
			return 240000.0;

		case '1':
		case 'b':
		case 'B':
			return 120000.0;

		case '2':
		case 'c':
		case 'C':
			return 60000.0;

		case '3':
		case 'd':
		case 'D':
			return 30000.0;

		case '4':
		case 'e':
		case 'E':
			return 15000.0;

		case '5':
		case 'f':
		case 'F':
			return 7500.0;

		case '6':
		case 'g':
		case 'G':
			return 3750.0;

		case '7':
		case 'h':
		case 'H':
			return 1875.0;

		case '8':
		case 'i':
		case 'I':
			return 937.5;

		case '9':
		case 'j':
		case 'J':
			return 468.75;
	}
}

bool xBeatManager::HitBeat(DWORD dwPressTime)
{
	m_dwLastHitTime = dwPressTime - g_xGame.m_dwGameStartTime;

	if(m_bAddedBlockAlready)
	{
		m_iHitTimeIndex = 0;
		return false;
	}

	//Only allow them to try once per arrow
	m_bAddedBlockAlready = true;

	int hittime = abs((m_dwLastHitTime - (int)m_dwBeatTimes[m_iCurBeatIndex]));

	SetHitTimeIndex(g_xGameOptions, hittime);

#if EDITINGBEATMARKERS
	DEBUGLOG("HitBeat[%i]: %u %i %i %i\n", m_iCurBeatIndex, m_dwBeatTimes[m_iCurBeatIndex], m_dwLastHitTime, hittime, m_dwLastHitTime - (int)m_dwBeatTimes[m_iCurBeatIndex]);
#endif

	return hittime <= g_xGameOptions.m_iHitTime;
}

void xBeatManager::ResetBeats()
{
	m_iNumBeats				= 0;
	m_iCurBeatIndex			= 0;
	m_dwLastHitTime			= -BB_HITTIME_SCALEOUT * 2;
	m_iHitTimeIndex			= 0;
	m_bAddedBlockAlready	= false;
}
