#include "Paper.h"

void xFontLoad(xFont *pThis, const char *strFontName)
{
	char strobjectfile[256], strfontfile[256];
	xFileIO fileio;
	uint16_t version;
	int i;

	sprintf(strobjectfile, "Data/Fonts/%s.p2d", strFontName);
	sprintf(strfontfile, "Data/Fonts/%s.p2f", strFontName);

	pThis->m_pTexture = xGraphicsGetTexture(strobjectfile, 0);

	if(fileio.OpenFile(strfontfile, true, true))
		assert(0);

	// Get the version
	fileio.ReadData(&version, sizeof(uint16_t));

	// Get the number of characters
	fileio.ReadData(&pThis->m_iNumCharacters, sizeof(uint32_t));

	pThis->m_iCharWidths = (int*)dlmalloc(sizeof(int) * pThis->m_iNumCharacters);
	pThis->m_iCharHeights = (int*)dlmalloc(sizeof(int) * pThis->m_iNumCharacters);
	pThis->m_rectCharRects = (xRECTf*)dlmalloc(sizeof(xRECTf) * pThis->m_iNumCharacters);

	pThis->m_iSize = 0;

	for(i = 0; i < pThis->m_iNumCharacters; i++)
	{
		fileio.ReadData(&pThis->m_rectCharRects[i], sizeof(xRECTf));

		pThis->m_rectCharRects[i].top = 1.0f - pThis->m_rectCharRects[i].top;
		pThis->m_rectCharRects[i].bottom = 1.0f - pThis->m_rectCharRects[i].bottom;

		pThis->m_iCharWidths[i] = (pThis->m_rectCharRects[i].right - pThis->m_rectCharRects[i].left) * (float)pThis->m_pTexture->m_iWidth;
		pThis->m_iCharHeights[i] = (pThis->m_rectCharRects[i].top - pThis->m_rectCharRects[i].bottom) * (float)pThis->m_pTexture->m_iHeight;

		if((pThis->m_rectCharRects[i].top - pThis->m_rectCharRects[i].bottom) * pThis->m_pTexture->m_iHeight > pThis->m_iSize)
			pThis->m_iSize = (pThis->m_rectCharRects[i].top - pThis->m_rectCharRects[i].bottom) * (float)pThis->m_pTexture->m_iHeight;
	}

	fileio.CloseFile();

	pThis->m_bLoaded = 1;
}

void xFontRefreshRenderables(xFont *pThis)
{
	char strobjectfile[256];

	sprintf(strobjectfile, "Data/Fonts/%s.p2d", pThis->m_strObjectPath);

	pThis->m_pTexture = xGraphicsGetTexture(strobjectfile, 0);
}

/*int xFont::Render(char *strLine, int iX, int iY)
{
	int curx = iX;

	if(!m_pFontObject)
		return PE_RES_FONTOBJECTNOTLOADED;

	m_pFontObject->m_xColor.R = 255;
	m_pFontObject->m_xColor.G = 255;
	m_pFontObject->m_xColor.B = 255;
	m_pFontObject->m_xColor.A = 255;

	for(int i = 0; i < strlen(strLine); i++)
	{
		m_pFontObject->Render((int)strLine[i] - 32, curx, iY, m_clrColor1, &m_clrColor2);
		curx += GetWidth((int)strLine[i]);
	}

	return PE_RES_NOERROR;
}

int xFont::Render(char* strLine, int iX, int iY, const xColor *pColor)
{
	int curx = iX;

	if(!m_pFontObject)
		return PE_RES_FONTOBJECTNOTLOADED;

	for(int i = 0; i < strlen(strLine); i++)
	{
		m_pFontObject->Render((int)strLine[i] - 32, curx, iY, clrColor, &m_clrColor2);
		curx += GetWidth((int)strLine[i]);
	}

	return PE_RES_NOERROR;
}

int xFont::Render(char *strLine, int iX, int iY, float fScaleX, float fScaleY, float fRotation, const xColor *pColor)
{
	//Gotta rework xObject2D::Render() to accept Rotation
	//and Scaling parameters...if this is ever needed
	return PE_RES_NOERROR;
}

int xFont::RenderRadial(char *strLine, int iX, int iY, const xColor &clrColor, float fCharacterOffsetY, float fMaxDegrees)
{
	float curx = iX, cury = iY, curdegrees = fMaxDegrees;
	int length = strlen(strLine);
	int halfchar = ceil((float)length / 2.0) - 1;
	bool oddlength = (length % 2 == 1);
	float changey = fCharacterOffsetY;
	float changedegrees = (fMaxDegrees * -2.0) / float(length - 1);

	if(!m_pFontObject)
		return PE_RES_FONTOBJECTNOTLOADED;

	for(int i = 0; i < length; i++)
	{
		m_pFontObject->Render((int)strLine[i] - 32, curx, cury, curdegrees, clrColor, &m_clrColor2);
		curx += GetWidth((int)strLine[i]);

		if(i == halfchar)
			fCharacterOffsetY *= -1.0;

		if(oddlength || i != halfchar)
			cury += fCharacterOffsetY;

		curdegrees += changedegrees;
	}

	return PE_RES_NOERROR;
}
*/
