#include "Paper.h"

void xGUIButton::InitRenderable(const char *strThemeName, const char* strBackground, const char* strIconImage, int iIconFrame, const char* strText)
{
	char imagepath[256] = {0};

	if(!strBackground || strBackground[0] == '\0')
		sprintf(m_strBackgroundPath, "Data/Themes/%s/ButtonBG.p2d", strThemeName);
	else
		strcpy(m_strBackgroundPath, strBackground);

	if(m_bStretch)
	{
		m_pBackground = xSceneGraphCreateQuad(m_strBackgroundPath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 9, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuad9Update(m_pBackground);
	}
	else
	{
		m_pBackground = xSceneGraphCreateQuad(m_strBackgroundPath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 1, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuadUpdate(m_pBackground);
	}

	xGraphicsGetTextures(m_strBackgroundPath, &m_pTextures);

	if(strIconImage && strIconImage[0] != '\0')
	{
		m_pIconObject = xSceneGraphCreateQuad(strIconImage, iIconFrame);
		xRenderable2DQuadSetPosition(m_pIconObject, GetAbsoluteX() + m_fBorder, GetAbsoluteY() + m_fBorder);
		xRenderable2DQuadSetSize(m_pIconObject, GetWidth() - 2 * m_fBorder, GetHeight() - 2 * m_fBorder);
		xSceneGraphInsertQuad(m_pSceneGraph, m_pIconObject, 1, GetAbsoluteDepth() + 0.001, 0, 1);
		xRenderable2DQuadUpdate(m_pIconObject);

		xGraphicsGetTextures(strIconImage, &m_pIconTextures);
	}
	else if(strText && strText[0] != '\0')
	{
		m_pTextObject					= new xGUIText;
		m_pTextObject->Init();
		m_pTextObject->m_pParent		= this;
		m_pTextObject->m_pSceneGraph	= m_pSceneGraph;
		m_pTextObject->m_pFont			= m_pFont;
		m_pTextObject->m_bDisabled		= m_bDisabled;
		m_pTextObject->SetDepth(0.001);
		m_pTextObject->SetX(m_fBorder);
		m_pTextObject->SetY(m_fBorder);
		m_pTextObject->SetWidth(GetWidth());
		m_pTextObject->SetHeight(GetHeight());
		m_pTextObject->InitRenderable();
		m_pTextObject->SetText(strText);
	}
}

int xGUIButton::LoadObject(const char *strThemeName)
{
	int tempint;

	xGUIObject::LoadObject(strThemeName);

	m_fBorder = m_pParser->ToFlt("m_iBorder");

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"), m_pParser->GetVariable("m_strIconImage"), m_pParser->ToInt("m_iIconFrame"), m_pParser->GetVariable("m_strText"));

	if(m_pTextObject)
	{
		m_pParser->ToColor("m_colText", &m_pTextObject->m_xNormalColor);
		m_pParser->ToColor("m_colDisabledText", &m_pTextObject->m_xDisabledColor);
		m_pParser->ToColor("m_colHoverText", &m_pTextObject->m_xHoverColor);

		xColorCopy(&m_pTextObject->m_xRenderable.m_xColor, &m_pTextObject->m_xNormalColor);

		tempint = m_pParser->ToInt("m_iAlignment");

		if(tempint == 1)
		{
			m_pTextObject->SetAlignment(PE_GUITEXT_ALIGNMENT_CENTER);
			m_pTextObject->SetX(GetWidth() / 2.0);
		}
	}

	return PE_RES_NOERROR;
}

void xGUIButtonPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	xColor tempcolor;

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(((xGUIButton*)pThis)->m_pTextObject)
		((xGUIButton*)pThis)->m_pTextObject->m_bDisabled = pThis->m_bDisabled;

	if(pThis->m_bDisabled)
	{
		pThis->m_bClicked = false;
		pThis->UpdateState(false, dwTime);
		((xGUIButton*)pThis)->m_bWasClicked = false;
		((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_DISABLED);
		pThis->m_bHasFocus = false;

		if(((xGUIButton*)pThis)->m_pTextObject)
			xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xDisabledColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
	else if(g_xPaperAPI.m_xInput.m_lMouseX >= pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX <= pThis->GetAbsoluteX() + pThis->GetWidth() &&
	   g_xPaperAPI.m_xInput.m_lMouseY >= pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY <= pThis->GetAbsoluteY() + pThis->GetHeight())
	{
		if(!pThis->GetAbsoluteHidden())
		{
			if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
			{
				g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();
				pThis->UpdateState(true, dwTime);

				((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_CLICKED);
				((xGUIButton*)pThis)->m_bWasClicked = true;
				pThis->m_bHasFocus = true;

				if(((xGUIButton*)pThis)->m_pTextObject)
					xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));

				if(pThis->m_strDragCommand)
					pThis->m_pGUI->RunDragCommand(pThis);
			}
			else
			{
				if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.IsDown())
				{
					pThis->UpdateState(true, dwTime);

					if(((xGUIButton*)pThis)->m_bWasClicked)
					{
						((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_CLICKED);

						if(((xGUIButton*)pThis)->m_pTextObject)
							xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
					}
					else if(((xGUIButton*)pThis)->m_bToggled)
					{
						((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_TOGGLED);

						if(((xGUIButton*)pThis)->m_pTextObject)
							xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
					}
					else
					{
						((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_NONE);

						if(((xGUIButton*)pThis)->m_pTextObject)
							xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
					}
				}
				else
				{
					if(((xGUIButton*)pThis)->m_bWasClicked)
					{
						pThis->m_bClicked = true;

						if(pThis->m_strLClickCommand)
							pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);

						if(pThis->m_pClickSound)
							pThis->m_pClickSound->Play(g_xPaperAPI.m_fVolume);

						pThis->UpdateState(false, dwTime);
						((xGUIButton*)pThis)->m_bWasClicked = false;

						if(((xGUIButton*)pThis)->m_pTextObject)
							xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
					}
					else
					{
						pThis->m_bClicked = false;

						if(!pThis->m_bDisabled && !((xGUIButton*)pThis)->m_bToggled)
							((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_HOVER);

						if(((xGUIButton*)pThis)->m_pTextObject)
							xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
					}
				}
			}
		}

		if(pThis->GetAbsoluteFocus())
		{
			if(!pThis->m_bHovered)
			{
				pThis->m_bHovered = 1;
				pThis->m_bRanHoveredCommand = 0;
				pThis->m_dwHoverStateTime = dwTime;

				if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
				{
					if(!((xGUIButton*)pThis)->m_bToggled)
						((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_HOVER);

					if(pThis->m_pHoverSound)
						pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);

					if(((xGUIButton*)pThis)->m_pTextObject)
						xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
				}
			}
			else if(pThis->m_bRanHoveredCommand && pThis->m_strHoverCommand && dwTime - pThis->m_dwHoverStateTime > pThis->m_dwHoverDelay)
				pThis->m_pGUI->RunHoverCommand(pThis);
		}
		else
		{
			if(((xGUIButton*)pThis)->m_bToggled)
			{
				((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_TOGGLED);

				if(((xGUIButton*)pThis)->m_pTextObject)
					xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
			}
			else
			{
				((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_NONE);

				if(((xGUIButton*)pThis)->m_pTextObject)
					xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
			}
		}
	}
	else
	{
		if(!((xGUIButton*)pThis)->m_bWasClicked)
			pThis->m_bClicked = false;

		pThis->m_bHovered = false;

		if(!pThis->GetAbsoluteHidden())
		{
			if(((xGUIButton*)pThis)->m_bToggled)
			{
				((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_TOGGLED);

				if(((xGUIButton*)pThis)->m_pTextObject)
					xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
			}
			else
			{
				((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_NONE);

				if(((xGUIButton*)pThis)->m_pTextObject)
					xRenderable2DTextUpdateColor(&((xGUIButton*)pThis)->m_pTextObject->m_xText, xColorMultiply(&tempcolor, &((xGUIButton*)pThis)->m_pTextObject->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
			}
		}

		pThis->UpdateState(false, dwTime);

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;
	}
}

void xGUIButtonClearState(xGUIObject* pThis, DWORD dwTime)
{
	pThis->m_bHasFocus = false;
	pThis->m_bHovered = false;
	pThis->m_bClicked = false;
	pThis->UpdateState(false, dwTime);
	((xGUIButton*)pThis)->m_bWasClicked = false;
	((xGUIButton*)pThis)->m_bToggled = false;
	((xGUIButton*)pThis)->SetState(PE_GUI_BUTTONSTATE_NONE);

	xGUIObjectClearState(pThis, dwTime);
}

void xGUIButtonUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_bHasFocus)
		pThis->UpdateState(false, 0);

	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	xGUIObjectUpdate(pThis, dTime);
}

void xGUIButtonUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;

	xRenderable2DQuadUpdateAlpha(((xGUIButton*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);
	xRenderable2DQuadSetPosition(((xGUIButton*)pThis)->m_pBackground, pThis->GetAbsoluteX(), pThis->GetAbsoluteY());
	xRenderable2DQuadUpdateVisibility(((xGUIButton*)pThis)->m_pBackground, !pThis->GetAbsoluteHidden());

	if(pThis->m_bStretch)
		xRenderable2DQuad9Update(((xGUIButton*)pThis)->m_pBackground);
	else
		xRenderable2DQuadUpdate(((xGUIButton*)pThis)->m_pBackground);

	if(((xGUIButton*)pThis)->m_pIconObject)
	{
		xRenderable2DQuadUpdateAlpha(((xGUIButton*)pThis)->m_pIconObject, tempcolor.A);
		xRenderable2DQuadSetPosition(((xGUIButton*)pThis)->m_pIconObject, pThis->GetAbsoluteX() + ((xGUIButton*)pThis)->m_fBorder, pThis->GetAbsoluteY() + ((xGUIButton*)pThis)->m_fBorder);
		xRenderable2DQuadUpdate(((xGUIButton*)pThis)->m_pIconObject);
		xRenderable2DQuadUpdateVisibility(((xGUIButton*)pThis)->m_pIconObject, ((xGUIButton*)pThis)->m_pBackground->m_xRenderable2D.m_bVisible);
	}
	else if(((xGUIButton*)pThis)->m_pTextObject && ((xGUIButton*)pThis)->m_pTextObject->m_strBuffer)
		xGUITextUpdateRenderable(((xGUIButton*)pThis)->m_pTextObject);
}

void xGUIButtonUpdateDepth(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateDepth(((xGUIButton*)pThis)->m_pBackground, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());

	if(((xGUIButton*)pThis)->m_pIconObject)
		xRenderable2DQuadUpdateDepth(((xGUIButton*)pThis)->m_pIconObject, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth() + 0.001);
	else if(((xGUIButton*)pThis)->m_pTextObject)
		xGUITextUpdateDepth(((xGUIButton*)pThis)->m_pTextObject);

	xGUIObjectUpdateDepth(pThis);
}

void xGUIButtonRefreshRenderables(xGUIObject* pThis)
{
	xGraphicsGetTextures(((xGUIButton*)pThis)->m_strBackgroundPath, &((xGUIButton*)pThis)->m_pTextures);
	((xGUIButton*)pThis)->SetState(((xGUIButton*)pThis)->m_iButtonState);

	if(((xGUIButton*)pThis)->m_pIconObject)
		xRenderable2DQuadUpdateTexture(((xGUIButton*)pThis)->m_pIconObject, ((xGUIButton*)pThis)->m_pIconObject->m_pTextures[0]);
	else if(((xGUIButton*)pThis)->m_pTextObject)
		xGUITextRefreshRenderables(((xGUIButton*)pThis)->m_pTextObject);
}

void xGUIButton::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pBackground, false);

	if(m_pIconObject)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pIconObject, false);

	if(m_pTextObject)
	{
		m_pTextObject->Shutdown();
		delete m_pTextObject;
	}
}