#include "Paper.h"

int xGUIImage::LoadObject(const char *strThemeName)
{
	int frame;
	char *tempvariable;

	xGUIObject::LoadObject(strThemeName);

	m_bAnimated = m_pParser->ToBool("m_bAnimated");
	frame = m_pParser->ToInt("m_iFrame");

	m_pParser->ToColor("m_colColor", &m_xRenderable.m_xColor);
	m_xRenderable.m_xColor.A = m_pParser->ToFlt("m_iAlpha", 255) / 255.0f;

	strcpy(m_strImagePath, m_pParser->GetVariable("m_strImage"));
	m_pImageObject = xSceneGraphCreateQuad(m_strImagePath, frame);
	xRenderable2DQuadSetPosition(m_pImageObject, GetAbsoluteX(), GetAbsoluteY());
	xRenderable2DQuadSetSize(m_pImageObject, GetWidth(), GetHeight());
	xRenderable2DQuadSetRotation(m_pImageObject, GetRotation());

	if(m_bStretch)
	{
		xSceneGraphInsertQuad(m_pSceneGraph, m_pImageObject, 9, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuad9Update(m_pImageObject);
	}
	else
	{
		xSceneGraphInsertQuad(m_pSceneGraph, m_pImageObject, 1, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuadUpdate(m_pImageObject);
	}

	xGraphicsGetTextures(m_strImagePath, &m_pTextures);

	tempvariable = m_pParser->GetVariable("m_strSelBGImage");
	if(tempvariable && tempvariable[0] != '\0')
	{
		//m_pSelectedImageObject = g_xPaperAPI.m_xGraphics.Create2DObject(tempvariable);
		//m_pSelectedImageObject->SetSize(m_fWidth, m_fHeight);
	}

	return PE_RES_NOERROR;
}

void xGUIImagePreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(pThis->GetHidden())
		return;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = 0;

	if(pThis->m_bDisabled || pThis->GetAbsoluteHidden())
	{
		if(pThis->m_bHovered && pThis->m_strUnHoverCommand)
			pThis->m_pGUI->RunUnHoverCommand(pThis);

		pThis->m_bClicked = 0;
		pThis->m_bHasFocus = 0;
		pThis->m_bHovered = 0;

		//xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xDisabledColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
/*	else if(pThis->m_bShouldSelect)
	{
		if(pThis->m_pSelectionGroup && ((xGUIText*)pThis)->m_pSelectedEmitter)
		{
			if(!pThis->m_bSelected)
			{
				if(pThis->m_pHoverSound)
					pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);

				pThis->m_pSelectionGroup->ClearSelected();
				pThis->m_bSelected = true;

				((xGUIText*)pThis)->m_pSelectedEmitter->Reset();
			}
		}

		pThis->m_bShouldSelect = false;
	}
*/	else if(g_xPaperAPI.m_xInput.m_lMouseX >= pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX <= pThis->GetAbsoluteX() + pThis->GetWidth() &&
			g_xPaperAPI.m_xInput.m_lMouseY >= pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY <= pThis->GetAbsoluteY() + pThis->GetHeight())
	{
		if(pThis->m_pParent->GetAbsoluteFocus())
		{
			if(!pThis->m_bHovered)
			{
				pThis->m_bHovered = 1;
				pThis->m_bRanHoveredCommand = 0;
				pThis->m_dwHoverStateTime = dwTime;

				//xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));

/*				if(pThis->m_pSelectionGroup && ((xGUIText*)pThis)->m_pSelectedEmitter)
				{
					if(!pThis->m_bSelected)
					{
						if(pThis->m_pHoverSound)
							pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);

						pThis->m_pSelectionGroup->ClearSelected();
						pThis->m_bSelected = true;

						((xGUIText*)pThis)->m_pSelectedEmitter->Reset();
					}
				}
				else*/ if(pThis->m_pHoverSound)
					pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
			}
			else if(!pThis->m_bRanHoveredCommand && pThis->m_strHoverCommand && dwTime - pThis->m_dwHoverStateTime > pThis->m_dwHoverDelay)
				pThis->m_pGUI->RunHoverCommand(pThis);
		}

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(1))
		{
			g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();

			pThis->m_bHasFocus = 1;
			pThis->m_bClicked = 1;

			if(pThis->m_strLClickCommand)
			{
				pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);

				if(pThis->m_pClickSound)
					pThis->m_pClickSound->Play(g_xPaperAPI.m_fVolume);
			}
		}
		else
			pThis->m_bClicked = 0;
	}
	else
	{
		if(pThis->m_bHovered && pThis->m_strUnHoverCommand)
			pThis->m_pGUI->RunUnHoverCommand(pThis);

		pThis->m_bRanHoveredCommand = 1;
		pThis->m_bHovered = 0;
		pThis->m_bClicked = 0;

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = 0;

		//xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
	}

/*	if(pThis->m_bSelected)
	{
		if(g_xPaperAPI.m_xInput.m_keyLeft.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyUp.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_keyLeft.Eaten();
			g_xPaperAPI.m_xInput.m_keyUp.Eaten();
			pThis->SelectPrevious();

			if(pThis->m_pHoverSound)
				pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
		}
		else if(g_xPaperAPI.m_xInput.m_keyRight.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyDown.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_keyRight.Eaten();
			g_xPaperAPI.m_xInput.m_keyDown.Eaten();
			pThis->SelectNext();

			if(pThis->m_pHoverSound)
				pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
		}
		else if(g_xPaperAPI.m_xInput.m_keyEnter.JustPressed(true) || g_xPaperAPI.m_xInput.m_keySpace.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyNumEnter.JustPressed(true))
		{
			if(pThis->m_strLClickCommand)
			{
				g_xPaperAPI.m_xInput.m_keyEnter.Eaten();
				g_xPaperAPI.m_xInput.m_keySpace.Eaten();
				g_xPaperAPI.m_xInput.m_keyNumEnter.Eaten();

				pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);

				if(pThis->m_pClickSound)
					pThis->m_pClickSound->Play(g_xPaperAPI.m_fVolume);
			}
		}

		xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
*/}

void xGUIImageUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	if(((xGUIImage*)pThis)->m_bAnimated)
		xRenderable2DQuadUpdateAnimation(((xGUIImage*)pThis)->m_pImageObject, dTime);

	if(!pThis->GetHidden())
	{
		if(pThis->m_bSelected)
		{
			//((xGUIImage*)pThis)->m_pSelectedImageObject->m_fX = pThis->GetAbsoluteX() + pThis->m_fWidth / 2.0;
			//((xGUIImage*)pThis)->m_pSelectedImageObject->m_fY = pThis->GetAbsoluteY() + pThis->m_fHeight / 2.0;
			//((xGUIImage*)pThis)->m_pSelectedImageObject->Update(dTime);
			//((xGUIImage*)pThis)->m_pSelectedImageObject->Render();
		}

		//((xGUIImage*)pThis)->m_pImageObject->Render(((xGUIImage*)pThis)->m_iImageFrame, pThis->GetAbsoluteX(), pThis->GetAbsoluteY(), pThis->m_fWidth, pThis->m_fHeight, pThis->GetAbsoluteScaleX(), pThis->GetAbsoluteScaleY(), pThis->GetRotation(), pThis->GetAbsoluteColor());
	}

	xGUIObjectUpdate(pThis, dTime);
}

void xGUIImageUpdateRenderable(xGUIObject* pThis)
{
	xColor tempcolor;

	xRenderable2DQuadSetPosition(((xGUIImage*)pThis)->m_pImageObject, pThis->GetAbsoluteX(), pThis->GetAbsoluteY());
	xRenderable2DQuadSetRotation(((xGUIImage*)pThis)->m_pImageObject, pThis->GetRotation());
	xRenderable2DQuadSetSize(((xGUIImage*)pThis)->m_pImageObject, pThis->GetWidth() * pThis->GetAbsoluteScaleX(), pThis->GetHeight() * pThis->GetAbsoluteScaleY());
	xRenderable2DQuadUpdateVisibility(((xGUIImage*)pThis)->m_pImageObject, !pThis->GetAbsoluteHidden());
	xRenderable2DQuadUpdateColor(((xGUIImage*)pThis)->m_pImageObject, pThis->GetAbsoluteColor(&tempcolor));
	//DEBUGLOG("xGUIImageUpdateRenderable - %s - %i\n", pThis->m_strName, !pThis->GetAbsoluteHidden());

	if(((xGUIImage*)pThis)->m_bStretch)
		xRenderable2DQuad9Update(((xGUIImage*)pThis)->m_pImageObject);
	else
		xRenderable2DQuadUpdate(((xGUIImage*)pThis)->m_pImageObject);

	xGUIObjectUpdateRenderables(pThis);
}

void xGUIImageUpdateDepth(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateDepth(((xGUIImage*)pThis)->m_pImageObject, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());

	xGUIObjectUpdateDepth(pThis);
}

void xGUIImageRefreshRenderable(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateTexture(((xGUIImage*)pThis)->m_pImageObject, ((xGUIImage*)pThis)->m_pImageObject->m_pTextures[0]);
	xGraphicsGetTextures(((xGUIImage*)pThis)->m_strImagePath, &((xGUIImage*)pThis)->m_pTextures);
	xGUIObjectRefreshRenderables(pThis);
}

void xGUIImage::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pImageObject)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pImageObject, false);
}