/////////////////////////////////////////////////////////////////
// Name: xGUIImage.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles images for the GUI.
/////////////////////////////////////////////////////////////////
// - 01.23.2010, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUIIMAGE_H_
#define XGUIIMAGE_H_

#include "xGUIObject.h"

void xGUIImagePreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUIImageUpdate(xGUIObject* pThis, double dTime);
void xGUIImageUpdateRenderable(xGUIObject* pThis);
void xGUIImageUpdateDepth(xGUIObject* pThis);
void xGUIImageRefreshRenderable(xGUIObject* pThis);

class xGUIImage : public xGUIObject
{
public:
	xGUIImage()
	{
		pfnPreUpdate			= &xGUIImagePreUpdate;
		pfnUpdate				= &xGUIImageUpdate;
		pfnUpdateRenderables	= &xGUIImageUpdateRenderable;
		pfnUpdateDepth			= &xGUIImageUpdateDepth;
		pfnRefreshRenderables	= &xGUIImageRefreshRenderable;

		//m_pSelectedImageObject	= 0;
		m_iFrameCount			= 0;
		m_bAnimated				= 0;
	}

	int  LoadObject(const char *strThemeName);
	void SetTexture(xTexture **pTextures, int iFrame) { m_pTextures = pTextures; SetTextureFrame(iFrame); }
	void SetTextureFrame(int iFrame) { xRenderable2DQuadUpdateTexture(m_pImageObject, m_pTextures[iFrame]); }
	void Shutdown();

	char				  m_strImagePath[256];
	xRenderable2DQuad	 *m_pImageObject;
	//xObject2D	*m_pSelectedImageObject;
	xTexture			**m_pTextures;
	int					  m_iFrameCount;
	bool				  m_bAnimated;
};

#endif