#include "Paper.h"

void xGUISlider::InitRenderable(const char *strThemeName, const char *strBackground, const char *strThumb)
{
	char imagepath[256] = {0};
	char *tempvariable;

	if(!strBackground || strBackground[0] == '\0')
		sprintf(imagepath, "Data/Themes/%s/SliderHorizontal.p2d", strThemeName);
	else
		strcpy(imagepath, strBackground);

	m_pBackground = xSceneGraphCreateQuad(imagepath, 0);
	xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY() + m_fBGOffsetY);
	xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
	xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 3, GetAbsoluteDepth() + 0.001, 0, 1);
	xRenderable2DQuad3VerticalUpdate(m_pBackground);

	if(!strThumb || strThumb[0] == '\0')
		sprintf(imagepath, "Data/Themes/%s/SliderHorizontalThumb.p2d", strThemeName);
	else
		strcpy(imagepath, strThumb);

	m_pThumb = xSceneGraphCreateQuad(imagepath, 0);
	xRenderable2DQuadSetPosition(m_pThumb, GetAbsoluteX(), GetAbsoluteY());
	xSceneGraphInsertQuad(m_pSceneGraph, m_pThumb, 1, GetAbsoluteDepth() + 0.002, 0, 1);
	xRenderable2DQuadUpdate(m_pThumb);
}

int xGUISlider::LoadObject(const char *strThemeName)
{
	xGUIObject::LoadObject(strThemeName);

	m_fBGOffsetY = m_pParser->ToFlt("m_fBGOffsetY");
	m_iNumObjects = m_pParser->ToFlt("m_iNumValues");

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"), m_pParser->GetVariable("m_strThumb"));

	return PE_RES_NOERROR;
}

void xGUISliderPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(pThis->m_bDisabled || pThis->GetAbsoluteHidden())
		((xGUISlider*)pThis)->m_bDragging = false;

	if(((xGUISlider*)pThis)->m_bDragging)
	{
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.IsDown())
		{
			((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX = g_xPaperAPI.m_xInput.m_lMouseX - ((xGUISlider*)pThis)->m_dwThumbClickOffset;

			if(((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX < pThis->GetAbsoluteX())
				((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX = pThis->GetAbsoluteX();
			else if(((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX + ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fWidth > pThis->GetAbsoluteX() + pThis->GetWidth())
				((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX = pThis->GetAbsoluteX() + pThis->GetWidth() - ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fWidth;

			if(((xGUISlider*)pThis)->m_iNumObjects - ((xGUISlider*)pThis)->m_iVisibleObjects > 0)
			{
				float objectsize = pThis->GetWidth() / (float)((xGUISlider*)pThis)->m_iNumObjects;
				((xGUISlider*)pThis)->m_iTopObject = (((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX - pThis->GetAbsoluteX()) / objectsize;
			}

			if(pThis->m_strDragCommand)
				pThis->m_pGUI->RunDragCommand(pThis);

			xRenderable2DQuadUpdate(((xGUISlider*)pThis)->m_pThumb);
		}
		else
			((xGUISlider*)pThis)->m_bDragging = false;
	}
	else if(g_xPaperAPI.m_xInput.m_lMouseX >= pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX <= pThis->GetAbsoluteX() + pThis->GetWidth() &&
			g_xPaperAPI.m_xInput.m_lMouseY >= pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY <= pThis->GetAbsoluteY() + pThis->GetHeight())
	{
		if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
		{
			if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
			{
				g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();

				if(g_xPaperAPI.m_xInput.m_lMouseX >= ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX && g_xPaperAPI.m_xInput.m_lMouseX <= ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX + ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fWidth &&
				   g_xPaperAPI.m_xInput.m_lMouseY >= ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fY && g_xPaperAPI.m_xInput.m_lMouseY <= ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fY + ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fHeight)
				{
					((xGUISlider*)pThis)->m_dwThumbClickOffset = g_xPaperAPI.m_xInput.m_lMouseX - ((xGUISlider*)pThis)->m_pThumb->m_xRenderable2D.m_fX;
					((xGUISlider*)pThis)->m_bDragging = true;
				}
			}
		}
	}
	else
	{
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;
	}
}

void xGUISliderUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	xGUIObjectUpdate(pThis, dTime);
}

void xGUISliderUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;
	float objectsize = pThis->GetWidth() / (float)((xGUISlider*)pThis)->m_iNumObjects;

	xRenderable2DQuadUpdateVisibility(((xGUISlider*)pThis)->m_pBackground, !pThis->GetAbsoluteHidden());
	xRenderable2DQuadUpdateVisibility(((xGUISlider*)pThis)->m_pThumb, !pThis->GetAbsoluteHidden());

	xRenderable2DQuadUpdateAlpha(((xGUISlider*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);
	xRenderable2DQuadSetPosition(((xGUISlider*)pThis)->m_pBackground, pThis->GetAbsoluteX(), pThis->GetAbsoluteY() + ((xGUISlider*)pThis)->m_fBGOffsetY);
	xRenderable2DQuad3VerticalUpdate(((xGUISlider*)pThis)->m_pBackground);

	xRenderable2DQuadUpdateAlpha(((xGUISlider*)pThis)->m_pThumb, tempcolor.A);
	xRenderable2DQuadSetPosition(((xGUISlider*)pThis)->m_pThumb, pThis->GetAbsoluteX() + (float)((xGUISlider*)pThis)->m_iTopObject * objectsize, pThis->GetAbsoluteY());
	xRenderable2DQuadUpdate(((xGUISlider*)pThis)->m_pThumb);
}

void xGUISliderRefreshRenderables(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateTexture(((xGUISlider*)pThis)->m_pBackground, ((xGUISlider*)pThis)->m_pBackground->m_pTextures[0]);
	xRenderable2DQuadUpdateTexture(((xGUISlider*)pThis)->m_pThumb, ((xGUISlider*)pThis)->m_pThumb->m_pTextures[0]);
}

void xGUISlider::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pBackground, false);

	if(m_pThumb)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pThumb, false);
}
