/////////////////////////////////////////////////////////////////
// Name: xGUITextBox.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles textboxes for the GUI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUITEXTBOX_H_
#define XGUITEXTBOX_H_

#include "xGUIObject.h"

void xGUITextBoxPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUITextBoxUpdate(xGUIObject* pThis, double dTime);
void xGUITextBoxUpdateRenderables(xGUIObject* pThis);
void xGUITextBoxUpdateDepth(xGUIObject* pThis);
void xGUITextBoxRefreshRenderables(xGUIObject* pThis);

class xGUITextBox : public xGUIObject
{
public:
	xGUITextBox()
	{
		pfnPreUpdate			= &xGUITextBoxPreUpdate;
		pfnUpdate				= &xGUITextBoxUpdate;
		pfnUpdateRenderables	= &xGUITextBoxUpdateRenderables;
		pfnUpdateDepth			= &xGUITextBoxUpdateDepth;
		pfnRefreshRenderables	= &xGUITextBoxRefreshRenderables;

		m_bEditable			= 1;
		m_iCurrentLength	= 0;
		m_bMasked			= 0;
		m_dwCursorClickTime	= 0;
		m_bColorized		= 0;
	}

	void InitRenderable(const char *strThemeName, const char *strBackground);
	int  LoadObject(const char *strThemeName);
	void Shutdown();

	int HandlePaste(char *strInput, bool bOverwrite);

	char* GetText() { return m_strBuffer; }
	void  SetText(const char *strText) { if(!strText) return; if(m_strBuffer) delete [] m_strBuffer; m_iCurrentLength = strlen(strText); m_strBuffer = new char[m_iCurrentLength + 1]; strcpy(m_strBuffer, strText); m_xTextObject.SetText(strText); }

	//Settings
	xRenderable2DQuad	*m_pBackground;
	float				 m_fBorder;
	bool				 m_bEditable;
	bool				 m_bAllowSpace;
	int					 m_iMaxLength;
	char				*m_strBuffer;
	bool				 m_bMasked;
	bool				 m_bColorized;
	xColor				 m_xCursorColor;

	//Internal Vars
	xGUIText			 m_xTextObject;
	xRenderable2DLine	*m_pCursor;
	int					 m_iCurrentLength;
	DWORD				 m_dwCursorClickTime;
};

#endif