/////////////////////////////////////////////////////////////////
// Name: xGUIWindow.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles windows for the GUI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUIWINDOW_H_
#define XGUIWINDOW_H_

#include "xGUIObject.h"

void xGUIWindowPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUIWindowClearState(xGUIObject* pThis, DWORD dwTime);
void xGUIWindowUpdate(xGUIObject* pThis, double dTime);
void xGUIWindowUpdateRenderables(xGUIObject* pThis);
void xGUIWindowRefreshRenderables(xGUIObject* pThis);

class xGUIWindow : public xGUIObject, public xPoolItem<xGUIWindow>
{
public:
	xGUIWindow()
	{
		pfnPreUpdate			= &xGUIWindowPreUpdate;
		pfnClearState			= &xGUIWindowClearState;
		pfnUpdate				= &xGUIWindowUpdate;
		pfnUpdateRenderables	= &xGUIWindowUpdateRenderables;
		pfnRefreshRenderables	= &xGUIWindowRefreshRenderables;

		m_strPostLoadCommand = 0;
		m_strKeyPressCommand = 0;
		m_bPendingClose = 0;
	}

	int  Init(xSceneGraph *pSceneGraph, xGUI *pGUI, xGUIWindowList *pMyWindowList, const char *strFile, float fDepth);
	int  LoadWindow(float fDepth);
	void UpdateWindowDepth(float fNewDepth);
	void Shutdown();
	
	void Hide();
	void Show();

	xGUIObjectList* GetNextTabIndexObject(xGUIObjectList *pCurrentlyFocused);

	char  *m_strPostLoadCommand;
	char **m_strPostLoadParams;
	char  *m_strKeyPressCommand;
	char **m_strKeyPressParams;

	RECT m_rectTitleDragRgn;
	bool m_bTitleBar;
	bool m_bCloseButton;
	bool m_bDragable;
	bool m_bDragTitleOnly;
	bool m_bDragging;
	bool m_bClosable;
	bool m_bCollapsable;
	bool m_bCollapsed;
	bool m_bAlwaysOnTop;
	bool m_bAlwaysOnBottom;
	bool m_bAlwaysFocused;
	bool m_bSizable;

	float m_fMainOffsetX;
	float m_fMainOffsetY;
	float m_fTitleBarX;
	float m_fTitleBarY;
	float m_fTitleBarWidth;
	float m_fTitleBarHeight;
	float m_fCloseButtonX;
	float m_fCloseButtonY;
	float m_fCloseButtonWidth;
	float m_fCloseButtonHeight;

	bool m_bPendingClose;

	xRenderable2DQuad  *m_pWindow;
	//xObject2D	  *m_pTitleBar;
	//xObject2D	  *m_pCloseButton;

	xGUISelectionGroup	**m_pSelectionGroups;
};

#endif