#include "Paper.h"

int xLinuxFileIO::OpenFile(char* strFileName, bool bReadOnly, bool bBinary)
{
	m_strPathName = strFileName;

	if(bReadOnly == true)
	{
		if(bBinary == true)
		{
			m_pFile = fopen(strFileName, "rb");
			if(m_pFile == NULL)
				return PE_RES_FILEDOESNOTEXIST;
		}
		else
		{
			m_pFile = fopen(strFileName, "r");
			if(m_pFile == NULL)
				return PE_RES_FILEDOESNOTEXIST;
		}
	}
	else
	{
		if(bBinary == true)
		{
			m_pFile = fopen(strFileName, "wb");
			if(m_pFile == NULL)
				return PE_RES_FILEOPENERROR;
		}
		else
		{
			m_pFile = fopen(strFileName, "w+");
			if(m_pFile == NULL)
				return PE_RES_FILEOPENERROR;
		}
	}

	return PE_RES_NOERROR;
}

int xLinuxFileIO::ReadData(void* pOutputData)
{
	long lSize = 0;

	if(m_pFile == NULL)
		return PE_RES_FILENOTOPEN;

	lSize = sizeof(pOutputData);

	fread(pOutputData, 1, lSize, m_pFile);

	if(pOutputData == NULL)
		return PE_RES_FILEREADERROR;

	return PE_RES_NOERROR;
}

int xLinuxFileIO::WriteData(void* pInputData)
{
	if(m_pFile == NULL)
		return PE_RES_FILENOTOPEN;

	fwrite(pInputData, 1, sizeof(pInputData), m_pFile);

	return PE_RES_NOERROR;
}

int xLinuxFileIO::CloseFile()
{
	if(m_pFile == NULL)
		return PE_RES_FILENOTOPEN;

	fclose(m_pFile);

	return PE_RES_NOERROR;
}

bool xLinuxFileIO::IsOpen()
{
	if(m_pFile == NULL)
		return false;
	else
		return true;
}

int xLinuxFileIO::WriteString(char* strOutputText)
{
	if(m_pFile == NULL)
		return PE_RES_FILENOTOPEN;

	fputs(strOutputText, m_pFile);

	return PE_RES_NOERROR;
}

int xLinuxFileIO::ReadToEnd(void* pOutputData)
{
	long lSize = 0;

	if(m_pFile == NULL)
		return PE_RES_FILENOTOPEN;

	fseek (m_pFile, 0, SEEK_END);
	lSize = ftell(m_pFile);

	fread(pOutputData, 1, lSize, m_pFile);

	if(pOutputData == NULL)
		return PE_RES_FILEREADERROR;

	return PE_RES_NOERROR;
}