#include "peGame.h"

int xOptions::LoadOptions(const char *strOptionsFile)
{
	char function[100];
	char params[3][50] = {"blah", "bloo", "blam"};

	if(m_xParser.m_xFile.FileExists(strOptionsFile))
	{
		m_xParser.OpenScript(strOptionsFile);
		m_xParser.ReadLine(function, params[0], params[1], params[2]);

		if(m_xParser.GetVariable("m_bFirstRun"))
		{
			m_bFirstRun = m_xParser.ToBool("m_bFirstRun");
			m_iScreenWidth = m_xParser.ToInt("m_iScreenWidth");
			m_iScreenHeight = m_xParser.ToInt("m_iScreenHeight");
			m_bFullScreen = m_xParser.ToBool("m_bFullscreen");

			m_bCharacterOutlines = m_xParser.ToBool("m_bCharacterOutlines");
			m_bLimitedParticles = m_xParser.ToBool("m_bLimitedParticles");

			m_pButtons[KEY_RED]								= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRed"));
			m_pButtons[KEY_BLUE]							= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyBlue"));
			m_pButtons[KEY_YELLOW]							= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyYellow"));
			m_pButtons[KEY_ROTATEPIECE]						= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotatePiece"));
			m_pButtons[KEY_ROTATEPIECE_ALT]					= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotatePieceAlt"));
			m_pButtons[KEY_ROTATEBOARDCLOCKWISE]		= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotateBoardClockwise"));
			m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT]		= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotateBoardClockwiseAlt"));
			m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE]	= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotateBoardCounterClockwise"));
			m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT]	= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyRotateBoardCounterClockwiseAlt"));
			m_pButtons[KEY_DROPPIECE]						= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyThrowPiece"));
			m_pButtons[KEY_DROPPIECE_ALT]					= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyThrowPieceAlt"));
			m_pButtons[KEY_CLEAR]						= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyClear"));
			m_pButtons[KEY_TYPEMESSAGE]					= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyTypeMessage"));
			m_pButtons[KEY_PAUSE]						= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyPause"));
			m_pButtons[KEY_GOTOMENU]					= g_xPaperAPI.m_xInput.GetKeyFromString(m_xParser.GetVariable("m_keyGotoMenu"));

			g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride = m_xParser.ToInt("m_iMaxSoundChannels");

			m_fMusicVolume = m_xParser.ToFlt("m_fMusicVolume");
			m_fSoundVolume = m_xParser.ToFlt("m_fSoundVolume");
			m_fVoiceOverVolume = m_xParser.ToFlt("m_fVoiceOverVolume");
		}
		else
			m_bFirstRun = true;
	}
	else
		m_bFirstRun = true;

	if(!m_pButtons[KEY_RED])
		m_pButtons[KEY_RED] = &g_xPaperAPI.m_xInput.m_keyUp;

	if(!m_pButtons[KEY_BLUE])
		m_pButtons[KEY_BLUE] = &g_xPaperAPI.m_xInput.m_keyRight;

	if(!m_pButtons[KEY_YELLOW])
		m_pButtons[KEY_YELLOW] = &g_xPaperAPI.m_xInput.m_keyLeft;

	if(!m_pButtons[KEY_ROTATEPIECE])
		m_pButtons[KEY_ROTATEPIECE] = &g_xPaperAPI.m_xInput.m_keyS;

	if(!m_pButtons[KEY_ROTATEPIECE_ALT])
		m_pButtons[KEY_ROTATEPIECE_ALT] = &g_xPaperAPI.m_xInput.m_keyDown;

	if(!m_pButtons[KEY_ROTATEBOARDCLOCKWISE])
		m_pButtons[KEY_ROTATEBOARDCLOCKWISE] = &g_xPaperAPI.m_xInput.m_keyD;

	if(!m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT])
		m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT] = &g_xPaperAPI.m_xInput.m_keyRight;

	if(!m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE])
		m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE] = &g_xPaperAPI.m_xInput.m_keyA;

	if(!m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT])
		m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT] = &g_xPaperAPI.m_xInput.m_keyLeft;

	if(!m_pButtons[KEY_DROPPIECE])
		m_pButtons[KEY_DROPPIECE] = &g_xPaperAPI.m_xInput.m_keyW;

	if(!m_pButtons[KEY_DROPPIECE_ALT])
		m_pButtons[KEY_DROPPIECE_ALT] = &g_xPaperAPI.m_xInput.m_keyUp;

	if(!m_pButtons[KEY_CLEAR])
		m_pButtons[KEY_CLEAR] = &g_xPaperAPI.m_xInput.m_keySpace;

	if(!m_pButtons[KEY_TYPEMESSAGE])
		m_pButtons[KEY_TYPEMESSAGE] = &g_xPaperAPI.m_xInput.m_keyT;

	if(!m_pButtons[KEY_PAUSE])
		m_pButtons[KEY_PAUSE] = &g_xPaperAPI.m_xInput.m_keyP;

	if(!m_pButtons[KEY_GOTOMENU])
		m_pButtons[KEY_GOTOMENU] = &g_xPaperAPI.m_xInput.m_keyEscape;

	if(g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride < 0)
		g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride = 0;

	g_xPaperAPI.m_bOutlineModels = m_bCharacterOutlines;
	g_xPaperAPI.m_bLimitParticles = m_bLimitedParticles;
	g_xPaperAPI.m_fVolume = m_fSoundVolume;

	return PE_RES_NOERROR;
}

int xOptions::SaveOptions(const char *strOptionsFile)
{
	xFileIO fileio;
	char temp[8];

	fileio.OpenFile(strOptionsFile, false, false);

	fileio.WriteString("m_bFirstRun = false\n");
	fileio.WriteString("m_iScreenWidth = ");
	fileio.WriteString(itoa(m_iScreenWidth, temp, 10));
	fileio.WriteString("\nm_iScreenHeight = ");
	fileio.WriteString(itoa(m_iScreenHeight, temp, 10));
	fileio.WriteString("\nm_bFullscreen = ");
	fileio.WriteString(m_bFullScreen ? "true\n" : "false\n");
	fileio.WriteString("m_bCharacterOutlines = ");
	fileio.WriteString(m_bCharacterOutlines ? "true\n" : "false\n");
	fileio.WriteString("m_bLimitedParticles = ");
	fileio.WriteString(m_bLimitedParticles ? "true\n" : "false\n");

	fileio.WriteString("\nm_keyRed = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_RED]));
	fileio.WriteString("\nm_keyBlue = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_BLUE]));
	fileio.WriteString("\nm_keyYellow = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_YELLOW]));
	fileio.WriteString("\nm_keyRotatePiece = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEPIECE]));
	fileio.WriteString("\nm_keyRotatePieceAlt = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEPIECE_ALT]));
	fileio.WriteString("\nm_keyRotateBoardClockwise = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEBOARDCLOCKWISE]));
	fileio.WriteString("\nm_keyRotateBoardClockwiseAlt = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT]));
	fileio.WriteString("\nm_keyRotateBoardCounterClockwise = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE]));
	fileio.WriteString("\nm_keyRotateBoardCounterClockwiseAlt = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT]));
	fileio.WriteString("\nm_keyThrowPiece = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_DROPPIECE]));
	fileio.WriteString("\nm_keyThrowPieceAlt = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_DROPPIECE_ALT]));
	fileio.WriteString("\nm_keyClear = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_CLEAR]));
	fileio.WriteString("\nm_keyTypeMessage = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_TYPEMESSAGE]));
	fileio.WriteString("\nm_keyPause = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_PAUSE]));
	fileio.WriteString("\nm_keyGotoMenu = ");
	fileio.WriteString(g_xPaperAPI.m_xInput.GetStringFromKey(m_pButtons[KEY_GOTOMENU]));

	fileio.WriteString("\n\nm_iMaxSoundChannels = ");
	fileio.WriteString(itoa(g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride, temp, 10));
	fileio.WriteString("\nm_fMusicVolume = ");
	sprintf(temp, "%1.2f", m_fMusicVolume);
	fileio.WriteString(temp);
	fileio.WriteString("\nm_fSoundVolume = ");
	sprintf(temp, "%1.2f", m_fSoundVolume);
	fileio.WriteString(temp);
	fileio.WriteString("\nm_fVoiceOverVolume = ");
	sprintf(temp, "%1.2f", m_fVoiceOverVolume);
	fileio.WriteString(temp);

	fileio.WriteString("\n");

	fileio.CloseFile();

	return PE_RES_NOERROR;
}

bool xOptions::LoadProfileByHash(char *strHash, xPlayerProfile *pPlayer)
{
	xFileIO fileio;
	char file[64];
	int i;

	sprintf(file, "profiles/%s.bbp", strHash);

	if(m_iResult = fileio.OpenFile(file, true, true))
		return false;

	if(m_iResult = fileio.ReadData(pPlayer, sizeof(xPlayerProfile)))
		return false;

	fileio.CloseFile();

	if(pPlayer->m_u16Version == 0)
	{
		memset(pPlayer->m_u32HighScores, 0, BB_MAXLEVELS);
		pPlayer->m_u32Currency = 0;
	}
	
/*	if(pPlayer->m_u16Version <= 1)
	{
		memset(pPlayer->m_bytePlayerMovesOwned, 0, BB_MAXPLAYERMOVES);
		pPlayer->m_bytePlayerMovesOwned[0] = 1;
		pPlayer->m_bytePlayerMovesOwned[BB_PLAYERMOVE_MOVESPERCATEGORY] = 1;

		memset(pPlayer->m_bytePlayerMovesSelected, BB_PLAYERMOVE_NONE, BB_MAXPLAYERMOVESLOTS);
		pPlayer->m_bytePlayerMovesSelected[0] = 0;
		pPlayer->m_bytePlayerMovesSelected[1] = BB_PLAYERMOVE_MOVESPERCATEGORY;
	}
	
	if(pPlayer->m_u16Version <= 2)
		pPlayer->m_bytePlayerMoveExplanationSeen = 0;
*/	
	if(pPlayer->m_u16Version <= 3)
		pPlayer->m_byteNoServerPortWarning = 0;

	if(pPlayer->m_u16Version <= 4)
	{
		pPlayer->m_byteSelectedDifficulty = 255;

		memset(pPlayer->m_u32HighScores, 0, BB_NUMDIFFICULTIES * BB_MAXLEVELS * sizeof(uint32_t));
	}

	if(pPlayer->m_u16Version <= 5)
	{
		pPlayer->m_byteSeenSingleplayerLogin = 0;
		memset(pPlayer->m_strLoginName, 0, BB_MAXLOGINNAMELENGTH);
		memset(pPlayer->m_strLoginPassword, 0, BB_MAXLOGINPASSLENGTH);
	}

	if(pPlayer->m_u16Version <= 6)
	{
		pPlayer->m_strLoginPassword[32] = '\0';
		memset(pPlayer->m_byteAchievementStatus, 0, BB_ACHIEVEMENTS_MAX);
	}

	if(pPlayer->m_u16Version <= 7)
		memset(pPlayer->m_u32LevelTimes, 0, BB_MAXLEVELS * sizeof(uint32_t));

	if(pPlayer->m_byteSelectedDifficulty < BB_NUMDIFFICULTIES)
	{
		for(i = 0; i < BB_NUMDIFFICULTIES; i++)
			pPlayer->m_u32HighScores[i][BB_LEVELS_MAX + 1] = 0;

		for(i = 1; i < BB_MAXLEVELS; i++)
		{
			if(pPlayer->m_u32HighScores[pPlayer->m_byteSelectedDifficulty][i] == 0)
			{
				pPlayer->m_iCurrentLevel = i;
				break;
	}
		}
	}

	// Store this as the default Profile
	fileio.OpenFile("profiles/Default.txt", false, false);
	fileio.WriteString(strHash);
	fileio.WriteString("\n");
	fileio.CloseFile();

	return true;
}

//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
int xOptions::LoadPlayerProfile(char *strProfileName, xPlayerProfile *pPlayer)
{
	char profilehash[24];

	g_xOptions.CreateProfileHash(strProfileName, profilehash);

	if(!LoadProfileByHash(profilehash, pPlayer))
		strcpy(pPlayer->m_strProfileName, strProfileName);

	return PE_RES_NOERROR;
}

int xOptions::SavePlayerProfile(xPlayerProfile *pPlayer)
{
	char ProfileHash[24], File[64];
	xFileIO fileio;

	pPlayer->m_u16Version = BB_PLAYERPROFILEVERSION;

	g_xOptions.CreateProfileHash(pPlayer->m_strProfileName, ProfileHash);

	memset(pPlayer->m_byteBuffer, 0, BB_PLAYERPROFILEBUFFERSIZE);

	sprintf(File, "profiles/%s.bbp", ProfileHash);
	if(m_iResult = fileio.OpenFile(File, false, true))
		assert(0);

	if(m_iResult = fileio.WriteData(pPlayer, sizeof(xPlayerProfile)))
		assert(0);

	fileio.CloseFile();

	// Store this as the default Profile
	fileio.OpenFile("profiles/Default.txt", false, false);
	fileio.WriteString(ProfileHash);
	fileio.WriteString("\n");
	fileio.CloseFile();

	return PE_RES_NOERROR;
}

xList<xPlayerProfile>* xOptions::GetAllAvailableProfiles()
{
	xFileIO fileio;
	char curhash[24] = {0};
	char curfilename[256] = {0};
	char curfilepath[256] = {0};
	xPlayerProfile *curplayerprofile;
	xList<xPlayerProfile> *returnlist = NULL;
	xList<xPlayerProfile> *curlistitem;

	fileio.StartFindFiles("./profiles/*.bbp");

	while(fileio.GetNextFile(curfilename))
	{
		curplayerprofile = new xPlayerProfile;

		sprintf(curfilepath, "./profiles/%s", curfilename);
		fileio.OpenFile(curfilepath, true, true);
		fileio.ReadData(curplayerprofile, sizeof(xPlayerProfile));
		fileio.CloseFile();

		CreateProfileHash(curplayerprofile->m_strProfileName, curhash);

		bool bHashMatches = true;
		for(int i = 0; i < 24 && curfilename[i] != '.'; i++)
		{
			if(curfilename[i] != curhash[i])
			{
				bHashMatches = false;
				break;
			}
		}

		if(bHashMatches)
		{
			if(!returnlist)
			{
				returnlist = new xList<xPlayerProfile>;
				returnlist->m_pData = curplayerprofile;
				curlistitem = returnlist;
			}
			else
			{
				curlistitem->m_pNext			= new xList<xPlayerProfile>;
				curlistitem->m_pNext->m_pPrev	= curlistitem;
				curlistitem						= curlistitem->m_pNext;
				curlistitem->m_pData			= curplayerprofile;
			}
		}
		else
		{
			delete curplayerprofile;
		}

		memset(curfilename, 0, 255);
		memset(curhash, 0, 24);
	}

	fileio.EndFindFiles();

	return returnlist;
}

//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
void xOptions::CreateProfileHash(char *strProfileName, char strOutHash[24])
{
	unsigned long long ProfileHashInt = 0, HashShift;
	int i, j, shift;

	j = strlen(strProfileName);
	shift = 0;
	for(i = 0; i < j; i++)
	{
		HashShift = strProfileName[i];
		ProfileHashInt += HashShift << shift;

		shift += 2;
	}

	HashShift = 10000000000000000000ULL;
	i = 0;
	while(ProfileHashInt > 0 && i < 24 && HashShift > 1)
	{
		if(ProfileHashInt > HashShift)
		{
			j = ProfileHashInt / HashShift;
			strOutHash[i++] = '0' + j;
			ProfileHashInt = ProfileHashInt % HashShift;
		}

		HashShift /= 10;
	}

	if(ProfileHashInt < 10)
		strOutHash[i++] = '0' + ProfileHashInt;

	strOutHash[i] = '\0';
}