/////////////////////////////////////////////////////////////////
// Name: xParser.h
/////////////////////////////////////////////////////////////////
// Description:
// - Parses a script file line by line and holds the parsed
//   information.
/////////////////////////////////////////////////////////////////
// - 27.10.2004, File Created, Dayle Flowers(Xienen)
//   Created and started the file and class.
/////////////////////////////////////////////////////////////////
#ifndef XPARSER_H_
#define XPARSER_H_

#include "xVector.h"
#include "xColor.h"
#include "xList.h"
#include "xFileIO.h"

typedef UInt32 DWORD;

class xVariable
{
public:
	xVariable() { memset(m_strName, 0, 255); memset(m_strValue, 0, 255); }
	~xVariable() {}
	void  CreateVariable(char* strName, char *strValue) { strcpy(m_strName, strName); strcpy(m_strValue, strValue); }
	void  SetValue(char *strValue) { memset(m_strValue, 0, 255); strcpy(m_strValue, strValue); }
	char* GetValue() { return m_strValue; }
	char* GetName() { return m_strName; }
protected:
	char m_strName[256];
	char m_strValue[256];
};
typedef xList<xVariable> xVariableList;

class xParser
{
public:
	xParser() { m_bFileOpen = false; }
	~xParser() {};
	int   OpenScript(const char *strFile);
	int   ReadLine(char *strFunction, char* strParam1, char* strParam2, char* strParam3);
	void  SplitParams(char *strParams, char* strParam1, char* strParam2, char* strParam3);
	int   SetVariable(char *strName, char *strValue);
	char* GetVariable(const char *strName);
	int   EndScript(bool bClearVariables = true);

	bool	ToBool	(const char *strValue) { strValue = GetVariable(strValue); if(!strValue) return 0; if(strValue[0] == 't' || strValue[0] == 'T' || strValue[0] == '1') return true; if(strValue[0] == 'f' || strValue[0] == 'F' || strValue[0] == '0') return false; return (bool)atoi(strValue); }
	int		ToInt (const char *strValue) { strValue = GetVariable(strValue); if(!strValue) return 0; return atoi(strValue); }
	float	ToFlt		(const char *strValue, float fDefault = 0) { strValue = GetVariable(strValue); if(!strValue) return fDefault; return (float)atof(strValue); }
	double	ToDbl (const char *strValue) { strValue = GetVariable(strValue); if(!strValue) return 0; return atof(strValue); }
	DWORD	ToDWd		(const char *strValue, DWORD dwDefault = 0) { strValue = GetVariable(strValue); if(!strValue) return dwDefault; return (DWORD)strtoul(strValue, 0, 10); }
	void	ToColor		(const char *strValue, xColor *pColor, xColor *pDefaultColor = 0);
	int		ToIntArray	(const char *strValue, int **pOutArray);
/*	RECT	ToRect() { return RECT{0, 0, 0, 0}; }
	xVector	ToVector() {return xVector{0, 0, 0}; }

	int AddCallbackFunction(void *pFunction, char *strName, int iNumParams, xParamTypes iParamType1, ...);
	int ExecCallbackFunction(char *strName, char *strParams);
*/
	xFileIO			m_xFile;

private:
	int  m_iResult;
	bool m_bFileOpen;

	//xCallbackFunctionList m_xCallbackFunctions;
	xVariableList	m_xVariableList;
};

#endif