/////////////////////////////////////////////////////////////////
// Name: xPlatform.h
/////////////////////////////////////////////////////////////////
// Description:
// - Miscellaneous Platform specific interface(other misc
//   platform specific functionality can be found in Main)
/////////////////////////////////////////////////////////////////
// - 7.6.2004, Update, Arto Ruotsalainen(Arex)
//   Comment stuff added to begin of the file.
//   Add new updates/fixes above this, so the old updates
//   will be at the bottom.
/////////////////////////////////////////////////////////////////
#ifndef XPLATFORM_H_
#define XPLATFORM_H_

//#include <winsock2.h>
//#include <windows.h>
//#include <mmsystem.h>
#include <time.h>
#include <sys/time.h>

#include "xResults.h"
#include "xFileIO.h"

//#pragma comment(lib, "winmm.lib")
//#pragma comment(lib, "wsock32.lib")

class xPlatform
{
public:
	xPlatform()
	{
		m_bRegisteredClass	= 0;
		m_iTitleBarHeight	= 0;
		m_iBorderSize		= 0;
	}

	int   Init();
	WindowPtr	MakeWindow(int iWidth, int iHeight, int iBPP, bool bFullScreen);
	Rect		GetScreenRect() { return m_rectWindow; }
	UInt32		GetTime() { timeval time; gettimeofday(&time, NULL); return (time.tv_sec * 1000) + (time.tv_usec / 1000); }
	void  GetDateAndTime(int &iDateYear, int &iDateMonth, int &iDateDay, int &iTimeHour, int &iTimeMinutes, int &iTimeSeconds);
	char* GetClipboardContents(char *strOut, int iMaxLength);
	void  Shutdown();

	int m_iTitleBarHeight;
	int m_iBorderSize;

protected:
	bool	m_bRegisteredClass;
	int		m_iResult;
	WindowPtr	m_pWindow;
	Rect		m_rectWindow;
};

#endif