/////////////////////////////////////////////////////////////////
// Name: xPlayerProfile.h
/////////////////////////////////////////////////////////////////
// Description:
// - Holds all stats for single player profiles.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XPLAYERPROFILE_H_
#define XPLAYERPROFILE_H_

#define BB_PLAYERPROFILESIZE		65536
#define BB_PLAYERPROFILEVERSION		8
#define BB_MAXPROFILENAMELENGTH		64
#define BB_NUMDIFFICULTIES			5
#define BB_MAXLEVELS				100
#define BB_MAXLOGINNAMELENGTH		32
#define BB_MAXLOGINPASSLENGTH		36
#define BB_MAXACHIEVEMENTS			256
#define BB_PLAYERPROFILEBUFFERSIZE	BB_PLAYERPROFILESIZE - 2 - 4 - BB_MAXPROFILENAMELENGTH - 4 * BB_NUMDIFFICULTIES * BB_MAXLEVELS - 4 - 255 - 10 - 1 - 1 - 1  - BB_MAXLOGINNAMELENGTH - BB_MAXLOGINPASSLENGTH - BB_MAXACHIEVEMENTS - 4 * BB_MAXLEVELS

//NOTE: Always keep this at 65536 bytes
struct xPlayerProfile
{
	uint16_t m_u16Version;
	int      m_iCurrentLevel;
	char     m_strProfileName[BB_MAXPROFILENAMELENGTH];
	uint32_t m_u32HighScores[BB_NUMDIFFICULTIES][BB_MAXLEVELS];
	uint32_t m_u32Currency;
	uint8_t  m_byteRemoved[255];
	uint8_t  m_byteRemoved2[10];
	uint8_t  m_byteRemoved3;
	uint8_t  m_byteNoServerPortWarning;
	uint8_t  m_byteSelectedDifficulty;
	uint8_t  m_byteSeenSingleplayerLogin;
	char     m_strLoginName[BB_MAXLOGINNAMELENGTH];
	char     m_strLoginPassword[BB_MAXLOGINPASSLENGTH];
	uint8_t  m_byteAchievementStatus[BB_MAXACHIEVEMENTS];
	uint32_t m_u32LevelTimes[BB_MAXLEVELS];
	uint8_t  m_byteBuffer[BB_PLAYERPROFILEBUFFERSIZE]; //Overflow and power of 2 alignment buffer
};

#endif