/////////////////////////////////////////////////////////////////
// Name: xPoolItem.h
/////////////////////////////////////////////////////////////////
// Description:
// - A base class for all Pooled items
/////////////////////////////////////////////////////////////////
// - 7.6.2004, Update, Arto Ruotsalainen(Arex)
//   Comment stuff added to begin of the file.
//   Add new updates/fixes above this, so the old updates
//   will be at the bottom.
/////////////////////////////////////////////////////////////////
#ifndef XPOOLITEM_H_
#define XPOOLITEM_H_

template<class T>
class xPoolItem
{
public:
	xPoolItem()
	{
		m_pPrev = 0;
		m_pNext = 0;
		m_iReferenceCount = 0;
		m_bLoaded = false;
		memset(m_strObjectPath, 0, 255);
	}

	~xPoolItem()
	{
		memset(m_strObjectPath, 0, 255);
		m_pPrev = 0;
		m_pNext = 0;
	}

	char* GetObjectPath() { return m_strObjectPath; }
	void SetObjectPath(const char* strObjectPath) { strcpy(m_strObjectPath, strObjectPath); }

	xPoolItem<T>* m_pPrev;
	xPoolItem<T>* m_pNext;

	int  m_iReferenceCount;
	bool m_bLoaded;
protected:
	char m_strObjectPath[256];
};

#endif