#ifndef XSONG_H_
#define XSONG_H_

#include "xPaper.h"
#include "xAudioStream.h"

extern xPaper g_xPaperAPI;

class xSong
{
public:
	xSong()
	{
		m_pTrack = NULL;
	}

	FORCE_INLINE void Load(char* strSongFile, bool bLooping = 0);
	FORCE_INLINE void Play(bool bReset, float fVolume = 1.0);
	FORCE_INLINE void ContinuePlaying() { m_pTrack->ContinuePlaying(); }
	FORCE_INLINE void Stop();

	void  SetVolume(float fVolume) { m_pTrack->SetVolume(fVolume); }
	DWORD GetTime() { return m_pTrack->GetTime(); }
	DWORD GetLength() { return m_pTrack->GetLength(); }

	xAudioStream* m_pTrack;
	DWORD         m_dwMusicTime;
};

void xSong::Load(char *strSongFile, bool bLooping)
{
	if(m_pTrack)
		g_xPaperAPI.m_xAudio.UnloadMusic(m_pTrack);

	char trackpath[256];
	sprintf(trackpath, BB_MUSICTRACK_PATH, strSongFile, strSongFile);
	m_pTrack = g_xPaperAPI.m_xAudio.LoadMusic(trackpath, bLooping);

	m_dwMusicTime = 0;
}

void xSong::Play(bool bReset, float fVolume)
{
	m_pTrack->SetVolume(fVolume);

	if(bReset)
	{
		m_dwMusicTime = 0;
		m_pTrack->SetTime(0);
	}
	else
		m_pTrack->SetTime(m_dwMusicTime);

	m_pTrack->Play();
}

void xSong::Stop()
{
	if(m_pTrack)
	{
		m_dwMusicTime = m_pTrack->GetTime();

		m_pTrack->Stop();
	}
}

#endif